import _regeneratorRuntime from "@babel/runtime/regenerator";
var _jsxFileName = "/home/zaman/Documents/GitLab/bayt/formbuilder/src/components/toolbar/field-forms/Radio.js";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from "react";
import SimpleTabs from "../../../utils/Tabs/SimpleTabs";
import TextInput from "../../../utils/inputs/TextInput";
import Checkbox from "../../../utils/checkboxs/Checkbox";
import ValidateField from "../../../utils/validations/ValidateField";
import Button from "@material-ui/core/Button";
import { disableFieldEdit as _disableFieldEdit } from "../../../actions/toolbarActions";
import { createField as _createField, deleteField as _deleteField, deleteNewField as _deleteNewField, updateField as _updateField } from "../../../actions/formActions";
import { connect } from "react-redux";
import PredefinedValues from "../../../utils/predefined-values";
import Choices from "../../../utils/choices";
import { Scrollbars } from "react-custom-scrollbars";
import ConditionalLogic from "../../../utils/conditional-logic";
import axios from "axios";
import { addCategory as _addCategory, setIsOptionUpdated as _setIsOptionUpdated, updateCategoryOptions as _updateCategoryOptions } from '../../../actions/predefinedActions';
import { generateUUID, getHeight, getUniqueNumber } from '../../../utils/helpers';
import FieldRenderer from "./utils/FieldRenderer";
import { radioFieldsConfigs } from "./utils/radioFieldConfigs";
import { processLocalFields } from "./utils/helpers";
import SearchableSelect from "../../../utils/selects/SearchableSelect";
import { Dialog, DialogActions, DialogTitle, DialogContent, IconButton } from "@material-ui/core";
import { Check, Close } from "@material-ui/icons";
import Typography from '@material-ui/core/Typography';
import EmailComplete from "../../../utils/selects/EmailComplete";
var basicTabTitle = {
  en: "Basic Settings",
  ar: "الإعدادات الأساسية"
};
var advanceTabTitle = {
  en: "Advance Settings",
  ar: "إعدادات متقدمة"
};
var machineNameLabel = {
  en: "Machine Name/Field ID",
  ar: "إسم الألة"
};
var visibilityLabel = {
  en: "Visibility",
  ar: "الرؤية"
};
var cancelLabel = {
  en: "Cancel",
  ar: "إلغاء"
};
var saveLabel = {
  en: "Save",
  ar: "حفظ"
};
var choiceLabel = {
  en: "Choices",
  ar: "خيارات"
};
var enableOtherChoiceLabel = {
  en: 'Enable "Other" Choice',
  ar: "تمكين خيار آخر"
};
var visibleLabel = {
  en: "Visible",
  ar: "مرئي"
};
var hiddenLabel = {
  en: "Hidden",
  ar: "مختفي"
};

var Radio = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Radio, _React$Component);

  function Radio(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleTabChange", function (e, newValue) {
      _this.setState({
        activeTab: newValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      var _this$setState;

      if (name === "machineName") {
        _this.setState(_extends({}, _this.state, {
          updatedMachineName: val
        }));

        return;
      }

      var updatedErrors = _extends({}, _this.errors);

      if (updatedErrors.hasOwnProperty(name)) delete updatedErrors[name];

      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState.errors = updatedErrors, _this$setState));
    });

    _defineProperty(_assertThisInitialized(_this), "handleSaveField", function () {
      //check if machine name already exist
      var machineName = _this.state.machineName;

      _this.setState(_extends({}, _this.state, {
        isSaving: true
      }));

      if (machineName && _this.props.isOptionUpdated) {
        axios.get(_this.props.predefinedEndpoint + "/checkMachineNameExist/" + machineName + "/" + _this.state.uuid).then(function (response) {
          var _response$data;

          if (response == null ? void 0 : (_response$data = response.data) == null ? void 0 : _response$data.isExist) {
            _this.setState(_extends({}, _this.state, {
              isSameMachineName: response.data.field,
              isSaving: false
            }));
          } else {
            _this.saveField();
          }
        });
      } else {
        var updatedMachineName = _this.state.updatedMachineName;

        if (updatedMachineName) {
          var _Object$values;

          var haveMachineName = (_Object$values = Object.values(_this.props.fields)) == null ? void 0 : _Object$values.filter(function (item) {
            return item.machineName === updatedMachineName;
          });

          if (haveMachineName.length) {
            _this.setState(_extends({}, _this.state, {
              errors: _extends({}, _this.errors, {
                machineName: 'Machine name already exist in this form!'
              }),
              isSaving: false
            }));
          } else {
            _this.saveField();
          }
        } else {
          _this.saveField();
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
      var _this$state, name, machineName, order, conditionalLogic, isRequired, placeholder, helpText, subType, visibility, uuid, type, optionReferenceId, enableOther, parentId, hiddenRoles, optionRef, res, _res$data, newField, data;

      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _this$state = _this.state, name = _this$state.name, machineName = _this$state.machineName, order = _this$state.order, conditionalLogic = _this$state.conditionalLogic, isRequired = _this$state.isRequired, placeholder = _this$state.placeholder, helpText = _this$state.helpText, subType = _this$state.subType, visibility = _this$state.visibility, uuid = _this$state.uuid, type = _this$state.type, optionReferenceId = _this$state.optionReferenceId, enableOther = _this$state.enableOther, parentId = _this$state.parentId, hiddenRoles = _this$state.hiddenRoles;
              optionRef = _this.props.predefined.find(function (item) {
                return item.id === optionReferenceId;
              });

              if (!optionReferenceId) {
                _context2.next = 14;
                break;
              }

              _context2.prev = 3;

              if (!optionRef) {
                _context2.next = 9;
                break;
              }

              _context2.next = 7;
              return axios.post(_this.props.predefinedEndpoint + "/updateOptionRef", {
                data: optionRef
              });

            case 7:
              res = _context2.sent;

              if (res == null ? void 0 : res.data) {
                _this.props.addCategory(res.data);

                _this.setState(_extends({}, _this.state, {
                  optionReferenceId: res.data.id
                }));

                optionReferenceId = res == null ? void 0 : (_res$data = res.data) == null ? void 0 : _res$data.id;
              }

            case 9:
              _context2.next = 14;
              break;

            case 11:
              _context2.prev = 11;
              _context2.t0 = _context2["catch"](3);
              console.log(_context2.t0);

            case 14:
              newField = {
                name: name,
                machineName: machineName,
                uuid: uuid,
                type: type,
                order: order,
                parentId: parentId,
                config: {
                  conditionalLogic: conditionalLogic,
                  isConditionalEnabled: !!conditionalLogic.conditions.length,
                  isRequired: isRequired,
                  hiddenRoles: hiddenRoles,
                  placeholder: placeholder,
                  helpText: helpText,
                  subType: subType,
                  visibility: visibility,
                  optionReferenceId: optionReferenceId,
                  optionRef: optionRef,
                  enableOther: enableOther
                }
              };
              data = {
                field: newField
              };
              newField.locals = processLocalFields(_this.props.locals, _this.state);
              data.locals = processLocalFields(_this.props.locals, _this.state);
              ValidateField(newField, null, _this.props.currentLang).then( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
                return _regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _this.props.updateField(newField);

                        _context.next = 3;
                        return axios.post(_this.props.predefinedEndpoint + "/form/field/" + _this.props.formId, data);

                      case 3:
                        _this.props.disableFieldEdit();

                        _this.props.setIsOptionUpdated(false);

                        _this.setState(_extends({}, _this.state, {
                          isSaving: false
                        }));

                      case 6:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              })))["catch"](function (errors) {
                var keys = Object.keys(errors);

                if (keys[0] === "machineName" || keys[0] === "conditionalLogic") {
                  _this.handleTabChange({}, "advance");
                } else {
                  _this.handleTabChange({}, "basic");
                }

                _this.setState({
                  errors: errors,
                  isSaving: false
                });
              });

            case 19:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[3, 11]]);
    })));

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.deleteNewField();

      _this.props.disableFieldEdit();
    });

    _defineProperty(_assertThisInitialized(_this), "updateChoices", function (options) {
      _this.setState({
        options: options
      });
    });

    _defineProperty(_assertThisInitialized(_this), "insertChoices", function (cat) {
      //if it is system predefined options we can replace the reference
      if (cat.is_secure) {
        _this.setState(_extends({}, _this.state, {
          optionReferenceId: cat.id
        }));

        return;
      }

      var preDef = _this.props.predefined.find(function (item) {
        return item.id === _this.state.optionReferenceId;
      }); // clone predefined


      if (!_this.state.optionReferenceId || preDef.is_secure) {
        var clonePredef = {
          id: getUniqueNumber(),
          name: cat.name + '_clone_' + getUniqueNumber(),
          slug: cat.slug + '_clone_' + getUniqueNumber(),
          is_public: false,
          is_secure: false,
          isNew: true,
          options: cat.options.map(function (item) {
            return _extends({}, item, {
              id: getUniqueNumber()
            });
          })
        };

        _this.props.addCategory(clonePredef);

        _this.setState(_extends({}, _this.state, {
          optionReferenceId: clonePredef.id
        }));
      } else {
        var updatedOptions = [].concat(preDef.options, cat.options.map(function (item) {
          return _extends({}, item, {
            id: getUniqueNumber(),
            saveType: 'new'
          });
        }));

        _this.props.updateCategoryOptions(updatedOptions, preDef.slug);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "disablePredefined", function () {
      return new Promise(function (resolve, reject) {
        var options = [];

        for (var i = 0; i < _this.props.predefined.length; i++) {
          if (_this.props.predefined[i].id === _this.state.optionReferenceId) {
            _this.props.predefined[i].options.map(function (option) {
              options.push({
                name: option.name,
                value: option.value
              });
            });

            break;
          }
        }

        var newOptRef = {
          id: getUniqueNumber(),
          isNew: true,
          name: _this.state.machineName,
          slug: _this.state.machineName,
          isPublic: false,
          options: options
        };

        _this.props.addCategory(newOptRef);

        _this.setState({
          optionReferenceId: newOptRef.id
        }, function () {
          resolve(newOptRef);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "hanldeUpdateMachineName", function () {
      var updatedMachineName = _this.state.updatedMachineName;

      if (updatedMachineName) {
        var _Object$values2;

        var haveMachineName = (_Object$values2 = Object.values(_this.props.fields)) == null ? void 0 : _Object$values2.filter(function (item) {
          return item.machineName === updatedMachineName;
        });

        if (haveMachineName.length) {
          _this.setState(_extends({}, _this.state, {
            errors: _extends({}, _this.errors, {
              machineName: 'Machine name already exist in this form!'
            })
          }));
        } else {
          axios.get(_this.props.predefinedEndpoint + "/checkMachineNameExist/" + updatedMachineName + "/" + _this.state.uuid).then(function (response) {
            var _response$data2;

            if (response == null ? void 0 : (_response$data2 = response.data) == null ? void 0 : _response$data2.isExist) {
              _this.setState(_extends({}, _this.state, {
                sameMachineNameField: response.data.field,
                errors: _extends({}, _this.errors, {
                  machineName: null
                })
              }));
            } else {
              _this.setState(_extends({}, _this.state, {
                machineName: updatedMachineName,
                errors: _extends({}, _this.errors, {
                  machineName: null
                })
              }));
            }
          });
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderTabFields", function () {
      if (_this.state.activeTab === "basic") {
        return /*#__PURE__*/React.createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 398,
            columnNumber: 9
          }
        }, /*#__PURE__*/React.createElement(FieldRenderer, _extends({}, _this.state, {
          locals: _this.props.locals,
          fieldConfigs: radioFieldsConfigs,
          handleDataChange: _this.handleDataChange,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 399,
            columnNumber: 11
          }
        })), /*#__PURE__*/React.createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 416,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(Choices, {
          disablePredefined: _this.disablePredefined,
          predefined: _this.props.predefined,
          optionReferenceId: _this.state.optionReferenceId,
          required: true,
          label: choiceLabel[_this.props.currentLang],
          updateChoices: _this.updateChoices,
          choices: _this.state.options,
          error: _this.state.errors.options,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 417,
            columnNumber: 13
          }
        })), /*#__PURE__*/React.createElement(PredefinedValues, {
          insertChoices: _this.insertChoices,
          selected: _this.state.optionReferenceId,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 428,
            columnNumber: 11
          }
        }), /*#__PURE__*/React.createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 432,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(Checkbox, {
          checked: _this.state.enableOther,
          handleChange: function handleChange(val) {
            return _this.handleDataChange(val, "enableOther");
          },
          label: enableOtherChoiceLabel[_this.props.currentLang],
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 433,
            columnNumber: 13
          }
        })), /*#__PURE__*/React.createElement(Dialog, {
          open: !!_this.state.isSameMachineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 439,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(DialogTitle, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 440,
            columnNumber: 13
          }
        }, "Same Machine Name Alert"), /*#__PURE__*/React.createElement(DialogContent, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 441,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(Typography, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 442,
            columnNumber: 15
          }
        }, " Field(s) with this ", /*#__PURE__*/React.createElement(Typography, {
          display: "inline",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 442,
            columnNumber: 47
          }
        }, " ", _this.state.updatedMachineName, " "), " machine name already exist. if you proceed choices will reflect to other fields of same machine name ")), /*#__PURE__*/React.createElement(DialogActions, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 445,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(Button, {
          variant: "outlined",
          className: "ahfb-mr-2",
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              isSameMachineName: null
            }));
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 447,
            columnNumber: 15
          }
        }, "close"), /*#__PURE__*/React.createElement(Button, {
          variant: "contained",
          disableElevation: true,
          onClick: _this.saveField,
          autoFocus: true,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 460,
            columnNumber: 15
          }
        }, "Proceed"))));
      } else {
        var _this$state2, _this$state2$sameMach;

        return /*#__PURE__*/React.createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 475,
            columnNumber: 9
          }
        }, /*#__PURE__*/React.createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 476,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(TextInput, {
          value: _this.state.updatedMachineName || _this.state.updatedMachineName === "" ? _this.state.updatedMachineName : _this.state.machineName,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, "machineName");
          },
          label: machineNameLabel[_this.props.currentLang],
          required: true,
          autoFocus: true,
          error: _this.state.errors.machineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 477,
            columnNumber: 13
          }
        }), _this.state.updatedMachineName && _this.state.updatedMachineName !== _this.state.machineName && /*#__PURE__*/React.createElement("div", {
          style: {
            display: "flex",
            justifyContent: "end"
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 494,
            columnNumber: 17
          }
        }, /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              updatedMachineName: null,
              errors: _extends({}, _this.errors, {
                machineName: null
              })
            }));
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 495,
            columnNumber: 19
          }
        }, /*#__PURE__*/React.createElement(Close, {
          fontSize: "small",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 508,
            columnNumber: 21
          }
        })), /*#__PURE__*/React.createElement(IconButton, {
          size: "small",
          onClick: _this.hanldeUpdateMachineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 510,
            columnNumber: 19
          }
        }, /*#__PURE__*/React.createElement(Check, {
          fontSize: "small",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 514,
            columnNumber: 21
          }
        })))), /*#__PURE__*/React.createElement("div", {
          className: "ahfb-mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 519,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement("label", {
          className: "ahfb-mt-2 ahfb-mb-2 ahfb-align-center",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 520,
            columnNumber: 11
          }
        }, "Choose Role to Hide Field"), /*#__PURE__*/React.createElement(EmailComplete, {
          placeholder: 'Please select roles to hide',
          onChange: function onChange(internal) {
            return _this.handleDataChange(internal, 'hiddenRoles');
          },
          internal: _this.state.hiddenRoles,
          data: _this.props.allRoles,
          id: "recipient",
          includeSelectAll: false,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 523,
            columnNumber: 13
          }
        })), /*#__PURE__*/React.createElement(ConditionalLogic, {
          conditionalLogic: _this.state.conditionalLogic,
          isConditionalEnabled: _this.state.isConditionalEnabled,
          handleChange: _this.handleDataChange,
          errors: _this.state.errors.conditionalLogic ? _this.state.errors.conditionalLogic : [],
          predefined: _this.props.predefined,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 532,
            columnNumber: 11
          }
        }), /*#__PURE__*/React.createElement(Dialog, {
          open: !!_this.state.sameMachineNameField,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 544,
            columnNumber: 11
          }
        }, /*#__PURE__*/React.createElement(DialogTitle, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 545,
            columnNumber: 13
          }
        }, " Same Machine Name Alert!"), /*#__PURE__*/React.createElement(DialogContent, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 546,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(Typography, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 547,
            columnNumber: 15
          }
        }, "Field(s) with this ", /*#__PURE__*/React.createElement(Typography, {
          display: "inline",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 548,
            columnNumber: 36
          }
        }, " ", (_this$state2 = _this.state) == null ? void 0 : (_this$state2$sameMach = _this$state2.sameMachineNameField) == null ? void 0 : _this$state2$sameMach.machine_name, " "), " machine name already exist. if you proceed the choices will be replaced with existing one!")), /*#__PURE__*/React.createElement(DialogActions, {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 552,
            columnNumber: 13
          }
        }, /*#__PURE__*/React.createElement(Button, {
          variant: "outlined",
          className: "ahfb-mr-2",
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              sameMachineNameField: null
            }));
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 553,
            columnNumber: 15
          }
        }, "close"), /*#__PURE__*/React.createElement(Button, {
          variant: "contained",
          disableElevation: true,
          onClick: function onClick() {
            return _this.setState(_extends({}, _this.state, {
              machineName: _this.state.updatedMachineName,
              optionReferenceId: _this.state.sameMachineNameField.options_reference_id,
              sameMachineNameField: null
            }));
          },
          autoFocus: true,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 566,
            columnNumber: 15
          }
        }, "Procced"))));
      }
    });

    _this.state = _extends({
      activeTab: "basic",
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName,
      isSaving: false,
      hiddenRoles: props.hiddenRoles
    }, props.data.config);
    return _this;
  }

  var _proto = Radio.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        activeTab: "basic",
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName,
        isSaving: false
      }, nextProps.data.config));
    }
  };

  _proto.render = function render() {
    return /*#__PURE__*/React.createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 592,
        columnNumber: 7
      }
    }, /*#__PURE__*/React.createElement(SimpleTabs, {
      value: this.state.activeTab,
      handleChange: this.handleTabChange,
      options: [{
        label: basicTabTitle[this.props.currentLang],
        value: "basic"
      }, {
        label: advanceTabTitle[this.props.currentLang],
        value: "advance"
      }],
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 593,
        columnNumber: 9
      }
    }), /*#__PURE__*/React.createElement(Scrollbars, {
      style: {
        height: getHeight(true, true)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 604,
        columnNumber: 9
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "ahfb-p-3 ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 605,
        columnNumber: 11
      }
    }, this.renderTabFields(), /*#__PURE__*/React.createElement("div", {
      className: "ahfb-width-full ahfb-text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 607,
        columnNumber: 13
      }
    }, /*#__PURE__*/React.createElement(Button, {
      variant: "outlined",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 608,
        columnNumber: 15
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/React.createElement(Button, {
      variant: "contained",
      disableElevation: true,
      disabled: this.state.isSaving,
      onClick: this.handleSaveField,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 616,
        columnNumber: 15
      }
    }, saveLabel[this.props.currentLang])))));
  };

  return Radio;
}(React.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    locals: state.form.locals,
    currentLang: state.form.currentLang,
    formId: state.form.formId,
    isOptionUpdated: state.form.isOptionUpdated,
    fields: state.form.data
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch(_disableFieldEdit());
    },
    deleteNewField: function deleteNewField() {
      return dispatch(_deleteNewField());
    },
    createField: function createField(data) {
      return dispatch(_createField(data));
    },
    updateField: function updateField(data) {
      return dispatch(_updateField(data));
    },
    deleteField: function deleteField(id) {
      return dispatch(_deleteField(id));
    },
    addCategory: function addCategory(id) {
      return dispatch(_addCategory(id));
    },
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch(_updateCategoryOptions(data, slug));
    },
    setIsOptionUpdated: function setIsOptionUpdated(value) {
      return dispatch(_setIsOptionUpdated(value));
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(Radio);