import _regeneratorRuntime from "@babel/runtime/regenerator";
var _jsxFileName = "/home/zaman/Documents/GitLab/bayt/formbuilder/src/components/toolbar/field-forms/Video.js";

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import ValidateField from "../../../utils/validations/ValidateField";
import Button from "@material-ui/core/Button";
import { disableFieldEdit as _disableFieldEdit } from "../../../actions/toolbarActions";
import { createField as _createField, deleteField as _deleteField, updateField as _updateField, deleteNewField as _deleteNewField } from "../../../actions/formActions";
import { connect } from "react-redux";
import FileUpload from "../../../utils/file-upload";
import TextInput from "../../../utils/inputs/TextInput";
import { Scrollbars } from 'react-custom-scrollbars';
import FormHelperText from '@material-ui/core/FormHelperText';
import Checkbox from '../../../utils/checkboxs/Checkbox';
import { getHeight } from '../../../utils/helpers';
import { processLocalFields } from './utils/helpers';
import Radio from '../../../utils/radio/RadioGroup';
import axios from "axios";
import Typography from '@material-ui/core/Typography';
var urlLabel = {
  en: 'Url',
  ar: 'عنوان url'
};
var orLabel = {
  en: 'OR',
  ar: 'أو'
};
var uploadLabel = {
  en: 'File Upload',
  ar: 'تحميل الملف'
};
var linkLabel = {
  en: 'Link on Video',
  ar: 'رابط على الفيديو'
};
var autoplayLabel = {
  en: 'Auto Play Video',
  ar: 'تشغيل تلقائي للفيديو'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var saveLabel = {
  en: 'Save',
  ar: 'حفظ'
};
var youtubeLinkPlaceHolder = {
  en: 'YouTube preview will appear here',
  ar: 'youtube'
};
var youtubeLinkError = {
  en: 'Given url must be a valid youtube url',
  ar: 'يجب أن يكون عنوان URL المعطى عنوان URL صالحًا على youtube'
};
var youtubeVidePlaceHolder = {
  en: 'Youtube video will be shown here',
  ar: 'سيظهر فيديو يوتيوب هنا'
};
var options = [{
  value: 'video',
  label: 'Video'
}, {
  value: 'youtube',
  label: 'Youtube'
}];

var Video = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Video, _React$Component);

  function Video(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      if (_this.state.subType === 'youtube') {
        var _this$setState;

        _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState));

        var regExp = /^(?:https?:\/\/)?(?:m\.|www\.)?(?:youtu\.be\/|youtube\.com\/(?:embed\/|v\/|watch\?v=|watch\?.+&v=))((\w|-){11})(?:\S+)?$/;
        var match = val.match(regExp);

        if (match) {
          _this.setState({
            errors: {}
          });
        } else {
          _this.setState({
            errors: {
              youtube: youtubeLinkError[_this.props.currentLang]
            }
          });
        }
      } else {
        var _this$setState2;

        _this.setState((_this$setState2 = {}, _this$setState2[name] = val, _this$setState2.errors = {}, _this$setState2));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleVideoTypeSwitch", function (event) {
      _this.setState({
        subType: event.target.value
      });

      _this.setState({
        url: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", function () {
      _this.setState(_extends({}, _this.state, {
        isSaving: true
      }));

      var _this$state = _this.state,
          name = _this$state.name,
          machineName = _this$state.machineName,
          order = _this$state.order,
          subType = _this$state.subType,
          uuid = _this$state.uuid,
          type = _this$state.type,
          url = _this$state.url,
          href = _this$state.href,
          autoPlay = _this$state.autoPlay,
          visibility = _this$state.visibility,
          parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        config: {
          subType: subType,
          url: url,
          href: href,
          autoPlay: autoPlay,
          visibility: visibility
        }
      };
      var data = {
        field: newField
      };
      newField.locals = processLocalFields(_this.props.locals, _this.state);
      data.locals = processLocalFields(_this.props.locals, _this.state);
      ValidateField(newField, null, _this.props.currentLang).then( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this.props.updateField(newField);

                _context.next = 3;
                return axios.post(_this.props.predefinedEndpoint + "/form/field/" + _this.props.formId, data);

              case 3:
                _this.props.disableFieldEdit();

                _this.setState(_extends({}, _this.state, {
                  isSaving: false
                }));

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })))["catch"](function (err) {
        _this.setState({
          errors: err,
          isSaving: false
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.deleteNewField();

      _this.props.disableFieldEdit();
    });

    _defineProperty(_assertThisInitialized(_this), "extractVideoId", function (url) {
      // Regular expression to match YouTube video IDs in various URL formats
      var regex = /^(?:https?:\/\/)?(?:www\.)?(?:youtube\.com\/(?:watch\?.*v=|embed\/|v\/)|youtu\.be\/)([\w-]{11})(&(?:.*))?$/; // Match the URL against the regular expression

      var match = url.match(regex);

      if (match && match[1]) {
        return match[1]; // Return the extracted video ID
      }

      return null; // Return null if no match was found
    });

    _defineProperty(_assertThisInitialized(_this), "renderFields", function () {
      var _this$props$data;

      return /*#__PURE__*/React.createElement("div", {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 166,
          columnNumber: 7
        }
      }, /*#__PURE__*/React.createElement("div", {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 167,
          columnNumber: 9
        }
      }, /*#__PURE__*/React.createElement(Radio, {
        label: ((_this$props$data = _this.props.data) == null ? void 0 : _this$props$data.locals) && Object.keys(_this.props.data.locals).length !== 0 ? _this.props.currentLang === 'en' ? _this.props.data.name : _this.props.data.locals.ar.name_ar : _this.props.data.name,
        required: _this.props.data.config.isRequired,
        helperText: _this.props.data.config.helpText,
        options: options,
        labelProp: "label",
        valueProp: "value",
        value: _this.state.subType,
        handleChange: function handleChange(event) {
          return _this.handleVideoTypeSwitch(event);
        },
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 168,
          columnNumber: 11
        }
      })), _this.state.subType === 'video' ? /*#__PURE__*/React.createElement("div", {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 179,
          columnNumber: 43
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "ahfb-mb-4",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 180,
          columnNumber: 11
        }
      }, /*#__PURE__*/React.createElement(TextInput, {
        label: urlLabel[_this.props.currentLang],
        value: _this.state.url,
        handleChange: function handleChange(e) {
          return _this.handleDataChange(e.target.value, 'url');
        },
        autoFocus: true,
        error: _this.state.errors.url,
        disabled: true,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 181,
          columnNumber: 13
        }
      })), /*#__PURE__*/React.createElement("div", {
        className: "ahfb-separator ahfb-mb-4",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 183,
          columnNumber: 11
        }
      }, /*#__PURE__*/React.createElement("span", {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 183,
          columnNumber: 53
        }
      }, orLabel[_this.props.currentLang])), /*#__PURE__*/React.createElement("div", {
        className: "ahfb-mb-4",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 184,
          columnNumber: 11
        }
      }, /*#__PURE__*/React.createElement(FileUpload, {
        label: uploadLabel[_this.props.currentLang],
        fileUploadUrl: _this.props.fileUploadUrl,
        url: _this.state.url,
        updateUrl: function updateUrl(url) {
          return _this.handleDataChange(url, 'url');
        },
        variant: "videos",
        uploadable: true,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 185,
          columnNumber: 13
        }
      }), _this.state.errors.upload ? /*#__PURE__*/React.createElement(FormHelperText, {
        error: true,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 187,
          columnNumber: 15
        }
      }, _this.state.errors.upload) : ""), /*#__PURE__*/React.createElement("div", {
        className: "ahfb-mb-4",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 190,
          columnNumber: 11
        }
      }, /*#__PURE__*/React.createElement(TextInput, {
        label: linkLabel[_this.props.currentLang],
        value: _this.state.href,
        handleChange: function handleChange(e) {
          return _this.handleDataChange(e.target.value, 'href');
        },
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 191,
          columnNumber: 13
        }
      })), /*#__PURE__*/React.createElement(Checkbox, {
        checked: _this.state.autoPlay,
        handleChange: function handleChange(val) {
          return _this.handleDataChange(val, 'autoPlay');
        },
        label: autoplayLabel[_this.props.currentLang],
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 193,
          columnNumber: 11
        }
      })) : /*#__PURE__*/React.createElement("div", {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 194,
          columnNumber: 18
        }
      }, /*#__PURE__*/React.createElement(TextInput, {
        id: "youtube",
        label: youtubeLinkPlaceHolder[_this.props.currentLang],
        required: true,
        value: _this.state.url,
        handleChange: function handleChange(e) {
          return _this.handleDataChange(e.target.value, 'url');
        },
        formControlProps: {
          fullWidth: true
        },
        error: _this.state.errors.youtube,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 195,
          columnNumber: 11
        }
      }), _this.state.url.length && !Object.keys(_this.state.errors).length ? /*#__PURE__*/React.createElement("iframe", {
        id: "youtube-video",
        title: _this.state.url,
        style: {
          width: '100%',
          height: '250px',
          margin: '15px 0px'
        },
        src: "https://www.youtube.com/embed/" + _this.extractVideoId(_this.state.url),
        frameBorder: "0",
        allow: "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture",
        allowFullScreen: true,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 204,
          columnNumber: 79
        }
      }) : /*#__PURE__*/React.createElement("div", {
        style: {
          border: '2px dashed lightgrey',
          borderRadius: '20px',
          justifyContent: 'center',
          alignItems: 'center',
          height: '250px',
          display: 'flex',
          margin: '15px 0px'
        },
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 212,
          columnNumber: 17
        }
      }, /*#__PURE__*/React.createElement(Typography, {
        variant: 'h6',
        style: {
          color: '#5B5B7B'
        },
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 213,
          columnNumber: 13
        }
      }, youtubeLinkPlaceHolder[_this.props.currentLang]))));
    });

    _this.state = _extends({
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName,
      isSaving: false
    }, props.data.config);
    return _this;
  }

  var _proto = Video.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName,
        isSaving: false
      }, nextProps.data.config));
    }
  };

  _proto.render = function render() {
    return /*#__PURE__*/React.createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 224,
        columnNumber: 7
      }
    }, /*#__PURE__*/React.createElement(Scrollbars, {
      style: {
        height: getHeight(true, false)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 225,
        columnNumber: 9
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: "ahfb-p-3 ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 226,
        columnNumber: 11
      }
    }, this.renderFields(), /*#__PURE__*/React.createElement("div", {
      className: "ahfb-width-full ahfb-text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 228,
        columnNumber: 13
      }
    }, /*#__PURE__*/React.createElement(Button, {
      variant: "outlined",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 229,
        columnNumber: 15
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/React.createElement(Button, {
      variant: "contained",
      disabled: this.state.subType === 'youtube' ? this.state.errors.youtube || !this.state.url.length : false,
      disableElevation: true,
      onClick: this.saveField,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 232,
        columnNumber: 15
      }
    }, saveLabel[this.props.currentLang])))));
  };

  return Video;
}(React.Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    fileUploadUrl: state.form.fileUploadUrl,
    formId: state.form.formId,
    predefinedEndpoint: state.form.predefinedEndpoint,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch(_disableFieldEdit());
    },
    deleteNewField: function deleteNewField() {
      return dispatch(_deleteNewField());
    },
    createField: function createField(data) {
      return dispatch(_createField(data));
    },
    updateField: function updateField(data) {
      return dispatch(_updateField(data));
    },
    deleteField: function deleteField(id) {
      return dispatch(_deleteField(id));
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(Video);