"use strict";

exports.__esModule = true;
exports.setIsOptionUpdated = exports.updateCategoryOptions = exports.addCategory = void 0;

var addCategory = function addCategory(data) {
  return function (dispatch) {
    dispatch({
      type: 'ADD_PREDEFINED_CATEGORY',
      payload: {
        data: data
      }
    });
  };
};

exports.addCategory = addCategory;

var updateCategoryOptions = function updateCategoryOptions(options, slug) {
  return function (dispatch) {
    dispatch({
      type: 'UPDATE_CATEGORY_OPTIONS',
      payload: {
        slug: slug,
        options: options
      }
    });
    return Promise.resolve();
  };
};

exports.updateCategoryOptions = updateCategoryOptions;

var setIsOptionUpdated = function setIsOptionUpdated(value) {
  return function (dispatch) {
    dispatch({
      type: 'SET_IS_OPTION_UPDATED',
      payload: value
    });
  };
};

exports.setIsOptionUpdated = setIsOptionUpdated;