"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _formActions = require("../../actions/formActions");

var _toolbarActions = require("../../actions/toolbarActions");

var _reactRedux = require("react-redux");

var _Input = _interopRequireDefault(require("./fields-wrappers/Input"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _FileCopy = _interopRequireDefault(require("@material-ui/icons/FileCopy"));

var _Edit = _interopRequireDefault(require("@material-ui/icons/Edit"));

var _core = require("@material-ui/core");

var _Select = _interopRequireDefault(require("./fields-wrappers/Select"));

var _ButtonGroup = _interopRequireDefault(require("@material-ui/core/ButtonGroup"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Checkbox = _interopRequireDefault(require("./fields-wrappers/Checkbox"));

var _Radio = _interopRequireDefault(require("./fields-wrappers/Radio"));

var _Date = _interopRequireDefault(require("./fields-wrappers/Date"));

var _Content = _interopRequireDefault(require("./fields-wrappers/Content"));

var _File = _interopRequireDefault(require("./fields-wrappers/File"));

var _Section = _interopRequireDefault(require("./fields-wrappers/Section"));

var _Signature = _interopRequireDefault(require("./fields-wrappers/Signature"));

var _Image = _interopRequireDefault(require("./fields-wrappers/Image"));

var _Video = _interopRequireDefault(require("./fields-wrappers/Video"));

var _helpers = require("../../utils/helpers");

var _useWindowSize2 = require("../hooks/useWindowSize");

var _lodash = _interopRequireDefault(require("lodash"));

var _axios = _interopRequireDefault(require("axios"));

var _predefinedActions = require("../../actions/predefinedActions");

var _AlertDialog = _interopRequireDefault(require("../../utils/alertdialog/AlertDialog"));

var _jsxFileName = "/home/zaman/Documents/GitLab/bayt/formbuilder/src/components/app/FieldWrapper.js";

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function FieldWrapper(props) {
  var _this = this;

  var _React$useState = _react["default"].useState(false),
      options = _React$useState[0],
      setOptions = _React$useState[1];

  var _useWindowSize = (0, _useWindowSize2.useWindowSize)(),
      width = _useWindowSize.width;

  var _useState = (0, _react.useState)(false),
      openDelete = _useState[0],
      setOpenDelete = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      deleteLoading = _useState2[0],
      setDeleteLoading = _useState2[1];

  var enableEdit = function enableEdit(e) {
    props.enableFieldEdit(props.data.uuid);
  };

  var removeField = function removeField(e) {
    setOpenDelete(true); // if (props.editId === props.data.uuid) {
    //   props.disableFieldEdit();
    // }
    // props.deleteField(props.data.uuid);
  };

  var cloneField = function cloneField(e) {
    var _newData$config;

    var uuid = (0, _helpers.generateUUID)();
    var machineName = props.data.type + "-" + (0, _helpers.getUniqueNumber)();

    var newData = _lodash["default"].cloneDeep(props.data);

    newData.uuid = uuid;
    newData.machineName = machineName;

    if (["checkbox", "select", "radio"].includes(newData == null ? void 0 : newData.type) && (newData == null ? void 0 : (_newData$config = newData.config) == null ? void 0 : _newData$config.optionReferenceId)) {
      var preDef = props.predefined.find(function (item) {
        var _newData$config2;

        return item.id === (newData == null ? void 0 : (_newData$config2 = newData.config) == null ? void 0 : _newData$config2.optionReferenceId);
      });
      var clonePredef = {
        id: (0, _helpers.getUniqueNumber)(),
        name: preDef.name + '_clone_' + (0, _helpers.getUniqueNumber)(),
        slug: preDef.slug + '_clone_' + (0, _helpers.getUniqueNumber)(),
        is_public: false,
        is_secure: false,
        isNew: true,
        options: preDef.options.map(function (item) {
          return _extends({}, item, {
            id: (0, _helpers.getUniqueNumber)()
          });
        })
      };
      props.addCategory(clonePredef);
      newData.config = _extends({}, newData.config, {
        optionReferenceId: clonePredef.id
      });
      props.createField(newData); // clone predefined
      // axios
      //   .post(`${props.predefinedEndpoint}/clone-option-reference`, {
      //     optionRefId: newData?.config?.optionReferenceId,
      //   })
      //   .then((res) => {
      //     props.addCategory(res.data.cloneOptionRef);
      //     newData.config = {
      //       ...newData.config,
      //       optionReferenceId: res.data.cloneOptionRef.id,
      //     };
      //     props.createField(newData);
      //   });
    } else {
      props.createField(newData);
    }
  };

  var showOptions = function showOptions() {
    setOptions(true);
  };

  var hideOptions = function hideOptions() {
    setOptions(false);
  };

  var renderFields = function renderFields(predefined) {
    switch (props.data.type) {
      case "text":
        return /*#__PURE__*/_react["default"].createElement(_Input["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 107,
            columnNumber: 11
          }
        });

      case "checkbox":
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 111,
            columnNumber: 11
          }
        });

      case "radio":
        return /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 119,
            columnNumber: 11
          }
        });

      case "select":
        return /*#__PURE__*/_react["default"].createElement(_Select["default"], {
          data: props.data,
          predefined: predefined,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 127,
            columnNumber: 11
          }
        });

      case "content":
        return /*#__PURE__*/_react["default"].createElement(_Content["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 135,
            columnNumber: 11
          }
        });

      case "date":
        return /*#__PURE__*/_react["default"].createElement(_Date["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 139,
            columnNumber: 11
          }
        });

      case "file":
        return /*#__PURE__*/_react["default"].createElement(_File["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 143,
            columnNumber: 11
          }
        });

      case "image":
        return /*#__PURE__*/_react["default"].createElement(_Image["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 147,
            columnNumber: 11
          }
        });

      case "list":
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 150,
            columnNumber: 16
          }
        }, "list");

      case "quiz":
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 152,
            columnNumber: 16
          }
        }, "quiz");

      case "signature":
        return /*#__PURE__*/_react["default"].createElement(_Signature["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 155,
            columnNumber: 11
          }
        });

      case "survey":
        return /*#__PURE__*/_react["default"].createElement("h1", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 158,
            columnNumber: 16
          }
        }, "survey");

      case "video":
        return /*#__PURE__*/_react["default"].createElement(_Video["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 161,
            columnNumber: 11
          }
        });

      case "section":
        return /*#__PURE__*/_react["default"].createElement(_Section["default"], {
          data: props.data,
          currentLang: props.currentLang,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 165,
            columnNumber: 11
          }
        });

      default:
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 168,
            columnNumber: 16
          }
        }, " Default ");
    }
  };

  var className = "wrapper ahfb-shadow-1 ahfb-bg-white ahfb-ml-3 ahfb-mr-3 ahfb-p-3 ahfb-relative";

  if (props.first) {
    className = className + " first-field";
  }

  if (props.last) {
    className = className + " last-field";
  }

  var predefined = {};
  props.predefined.map(function (item) {
    predefined[item.id] = item;
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 184,
      columnNumber: 5
    }
  }, props.data.name || props.data.type === "content" || props.data.type === "image" || props.data.type === "video" ? /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    onMouseOver: showOptions,
    onMouseLeave: hideOptions,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 189,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "innerWrapper",
    style: {
      marginTop: width < 450 ? "30px" : "25px"
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 194,
      columnNumber: 11
    }
  }, options ? /*#__PURE__*/_react["default"].createElement(_ButtonGroup["default"], {
    className: "options-menu ahfb-absolute ahfb-" + (props.theme.direction ? props.theme.direction : "ltr") + "-1 ahfb-top-1 ahfb-float-right" // ahfb-zIndex  -> class remove
    ,
    size: "small",
    "aria-label": "outlined primary button group",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 199,
      columnNumber: 15
    }
  }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "delete-icon",
    onClick: removeField,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 206,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 207,
      columnNumber: 19
    }
  })), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "edit-icon",
    onClick: enableEdit,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 209,
      columnNumber: 17
    }
  }, /*#__PURE__*/_react["default"].createElement(_Edit["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 210,
      columnNumber: 19
    }
  })), props.data.type !== "section" ? /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    className: "clone-icon",
    onClick: cloneField,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 213,
      columnNumber: 19
    }
  }, /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
    title: "Clone field",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 214,
      columnNumber: 21
    }
  }, /*#__PURE__*/_react["default"].createElement(_FileCopy["default"], {
    fontSize: "small",
    color: "action",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 215,
      columnNumber: 23
    }
  }))) : "") : "", renderFields(predefined)), /*#__PURE__*/_react["default"].createElement(_AlertDialog["default"], {
    open: openDelete,
    title: "Delete Field",
    message: "Are you sure you want to delete the Field?",
    primaryLabel: "Delete",
    primaryAction: /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setDeleteLoading(true);
              _context.next = 3;
              return _axios["default"]["delete"](props.predefinedEndpoint + "/form/field/" + props.formId + "/" + props.data.uuid).then(function () {
                if (props.editId === props.data.uuid) {
                  props.disableFieldEdit();
                }

                props.deleteField(props.data.uuid);
                setOpenDelete(false);
                setDeleteLoading(false);
              });

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })),
    primaryActionLoading: deleteLoading,
    secondaryLabel: "Cancel",
    secondaryAction: function secondaryAction() {
      setOpenDelete(false);
    },
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 228,
      columnNumber: 11
    }
  })) : "");
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    editId: state.toolbar.editId,
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    theme: state.form.theme,
    formId: state.form.formId,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    createField: function createField(id) {
      return dispatch((0, _formActions.createField)(id));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    },
    enableFieldEdit: function enableFieldEdit(id) {
      return dispatch((0, _toolbarActions.enableFieldEdit)(id));
    },
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    addCategory: function addCategory(id) {
      return dispatch((0, _predefinedActions.addCategory)(id));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(FieldWrapper);

exports["default"] = _default;
module.exports = exports.default;