"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireDefault(require("react"));

var _ValidateField = _interopRequireDefault(require("../../../utils/validations/ValidateField"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _toolbarActions = require("../../../actions/toolbarActions");

var _formActions = require("../../../actions/formActions");

var _reactRedux = require("react-redux");

var _fileUpload = _interopRequireDefault(require("../../../utils/file-upload"));

var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _helpers = require("../../../utils/helpers");

var _helpers2 = require("./utils/helpers");

var _selectFieldConfigs = require("./utils/selectFieldConfigs");

var _FieldRenderer = _interopRequireDefault(require("./utils/FieldRenderer"));

var _axios = _interopRequireDefault(require("axios"));

var _imageFieldConfigs = require("./utils/imageFieldConfigs");

var _jsxFileName = "/home/zaman/Documents/GitLab/bayt/formbuilder/src/components/toolbar/field-forms/Image.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var urlLabel = {
  en: 'Url',
  ar: 'عنوان url'
};
var orLabel = {
  en: 'OR',
  ar: 'أو'
};
var uploadLabel = {
  en: 'File Upload',
  ar: 'تحميل الملف'
};
var cancelLabel = {
  en: 'Cancel',
  ar: 'إلغاء'
};
var saveLabel = {
  en: 'Save',
  ar: 'حفظ'
};

var Image = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Image, _React$Component);

  function Image(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      var _this$setState;

      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState.errors = {}, _this$setState));
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", function () {
      _this.setState(_extends({}, _this.state, {
        isSaving: true
      }));

      var _this$state = _this.state,
          name = _this$state.name,
          machineName = _this$state.machineName,
          order = _this$state.order,
          subType = _this$state.subType,
          uuid = _this$state.uuid,
          type = _this$state.type,
          url = _this$state.url,
          href = _this$state.href,
          tooltip = _this$state.tooltip,
          visibility = _this$state.visibility,
          parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        config: {
          subType: subType,
          url: url,
          href: href,
          tooltip: tooltip,
          visibility: visibility
        }
      };
      var data = {
        field: newField
      };
      newField.locals = (0, _helpers2.processLocalFields)(_this.props.locals, _this.state);
      data.locals = (0, _helpers2.processLocalFields)(_this.props.locals, _this.state);
      (0, _ValidateField["default"])(newField, null, _this.props.currentLang).then( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this.props.updateField(newField);

                _context.next = 3;
                return _axios["default"].post(_this.props.predefinedEndpoint + "/form/field/" + _this.props.formId, data);

              case 3:
                _this.props.disableFieldEdit();

                _this.setState(_extends({}, _this.state, {
                  isSaving: false
                }));

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      })))["catch"](function (err) {
        _this.setState({
          errors: err,
          isSaving: false
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.deleteNewField();

      _this.props.disableFieldEdit();
    });

    _defineProperty(_assertThisInitialized(_this), "renderFields", function () {
      return /*#__PURE__*/_react["default"].createElement("div", {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 114,
          columnNumber: 7
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-mb-4",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 115,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
        label: urlLabel[_this.props.currentLang],
        value: _this.state.url,
        handleChange: function handleChange(e) {
          return _this.handleDataChange(e.target.value, 'url');
        },
        autoFocus: true,
        error: _this.state.errors.url,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 116,
          columnNumber: 11
        }
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-separator ahfb-mb-4",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 118,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement("span", {
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 118,
          columnNumber: 51
        }
      }, orLabel[_this.props.currentLang])), /*#__PURE__*/_react["default"].createElement("div", {
        className: "ahfb-mb-4",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 119,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement(_fileUpload["default"], {
        label: uploadLabel[_this.props.currentLang],
        fileUploadUrl: _this.props.fileUploadUrl,
        url: _this.state.url,
        updateUrl: function updateUrl(url) {
          return _this.handleDataChange(url, 'url');
        },
        variant: "images",
        uploadable: true,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 120,
          columnNumber: 11
        }
      }), _this.state.errors.upload ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
        error: true,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 122,
          columnNumber: 13
        }
      }, _this.state.errors.upload) : ""), /*#__PURE__*/_react["default"].createElement(_FieldRenderer["default"], _extends({}, _this.state, {
        locals: _this.props.locals,
        fieldConfigs: _imageFieldConfigs.imageFieldsConfigs,
        handleDataChange: _this.handleDataChange,
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 125,
          columnNumber: 9
        }
      })));
    });

    _this.state = _extends({
      uploading: false,
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName,
      isSaving: false
    }, props.data.config);
    return _this;
  }

  var _proto = Image.prototype;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.data.uuid !== this.state.uuid) {
      this.setState(_extends({
        uploading: false,
        errors: {},
        uuid: nextProps.data.uuid,
        name: nextProps.data.name,
        type: nextProps.data.type,
        order: nextProps.data.order,
        parentId: nextProps.data.parentId,
        machineName: nextProps.data.machineName,
        isSaving: false
      }, nextProps.data.config));
    }
  };

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 143,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      style: {
        height: (0, _helpers.getHeight)(true, false)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 144,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-p-3 ahfb-my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 145,
        columnNumber: 11
      }
    }, this.renderFields(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 147,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "outlined",
      className: "ahfb-mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 148,
        columnNumber: 15
      }
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "contained",
      disableElevation: true,
      disabled: this.state.isSaving,
      onClick: this.saveField,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 151,
        columnNumber: 15
      }
    }, saveLabel[this.props.currentLang])))));
  };

  return Image;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    fileUploadUrl: state.form.fileUploadUrl,
    locals: state.form.locals,
    formId: state.form.formId,
    predefinedEndpoint: state.form.predefinedEndpoint,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    deleteNewField: function deleteNewField() {
      return dispatch((0, _formActions.deleteNewField)());
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    updateField: function updateField(data) {
      return dispatch((0, _formActions.updateField)(data));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Image);

exports["default"] = _default;
module.exports = exports.default;