"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Input = _interopRequireDefault(require("@material-ui/core/Input"));

var _InputAdornment = _interopRequireDefault(require("@material-ui/core/InputAdornment"));

var _ClickAwayListener = _interopRequireDefault(require("@material-ui/core/ClickAwayListener"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _MenuItem = _interopRequireDefault(require("@material-ui/core/MenuItem"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _Chip = _interopRequireDefault(require("@material-ui/core/Chip"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _Tooltip = _interopRequireDefault(require("@material-ui/core/Tooltip"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _lodash = _interopRequireDefault(require("lodash"));

var _core = require("@material-ui/core");

var _reactI18next = require("react-i18next");

var _jsxFileName = "/home/zaman/Documents/GitLab/bayt/formbuilder/src/utils/selects/EmailComplete.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelperLoose(o) { var i = 0; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (o = _unsupportedIterableToArray(o))) return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } i = o[Symbol.iterator](); return i.next.bind(i); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var validateEmail = function validateEmail(email) {
  var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
  return re.test(String(email).toLowerCase());
};

var arrElToInt = function arrElToInt(arr) {
  var newArr = [];

  _lodash["default"].map(arr, function (item) {
    newArr.push(parseInt(item, 10));
  });

  return newArr;
};

var EmailComplete = /*#__PURE__*/function (_React$PureComponent) {
  _inheritsLoose(EmailComplete, _React$PureComponent);

  function EmailComplete(props) {
    var _this;

    _this = _React$PureComponent.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "getSelectAll", function () {
      var selectAll = true; // eslint-disable-next-line no-restricted-syntax

      for (var _iterator = _createForOfIteratorHelperLoose(_this.state.filterData), _step; !(_step = _iterator()).done;) {
        var item = _step.value;

        if (_this.state.internal.indexOf(item == null ? void 0 : item.value) === -1 && _this.state.internal.indexOf(item == null ? void 0 : item.value) === -1) {
          selectAll = false;
          break;
        }
      }

      if (selectAll) {
        _this.setState({
          selectAll: 2
        });
      } else if (_this.state.internal.length || _this.state.external.length) {
        _this.setState({
          selectAll: 1
        });
      } else {
        _this.setState({
          selectAll: 0
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleMenuOpen", function () {
      _this.setState({
        open: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleMenuClose", function () {
      _this.setState({
        open: false,
        search: ''
      });

      _this.search({
        target: {
          value: ''
        }
      });
    });

    _defineProperty(_assertThisInitialized(_this), "search", function (e) {
      var str = e.target.value;
      var newFilterData = []; // eslint-disable-next-line eqeqeq

      if (!str || str == '') {
        newFilterData = _lodash["default"].cloneDeep(_this.state.data);
      } else {
        // eslint-disable-next-line array-callback-return
        _this.state.data.map(function (item) {
          if (item.label.toLowerCase().includes(str.toLowerCase())) {
            newFilterData.push(item);
          }
        });
      }

      _this.setState({
        filterData: newFilterData,
        search: e.target.value,
        searchError: null
      }, function () {
        _this.getSelectAll();
      });
    });

    _defineProperty(_assertThisInitialized(_this), "selectAll", function (e) {
      e.preventDefault(); // eslint-disable-next-line eqeqeq

      if (_this.state.selectAll == 0) {
        var external = [];
        var internal = []; // eslint-disable-next-line array-callback-return

        _this.state.filterData.map(function (item) {
          if (validateEmail(item == null ? void 0 : item.value)) {
            external.push(item == null ? void 0 : item.value);
          } else {
            internal.push(item == null ? void 0 : item.value);
          }
        });

        _this.setState({
          external: external,
          internal: internal,
          selectAll: 2
        });

        _this.props.onChange(internal, external);
      } else {
        _this.reset();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "reset", function () {
      _this.setState({
        internal: [],
        external: [],
        selectAll: 0
      });

      _this.props.onChange([], []);
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (e, value) {
      e.preventDefault();

      if (validateEmail(value)) {
        // eslint-disable-next-line react/no-access-state-in-setstate
        var external = _lodash["default"].cloneDeep(_this.state.external);

        if (external.indexOf(value) === -1) {
          external.push(value);
        } else {
          external.splice(external.indexOf(value), 1);
        }

        _this.setState({
          external: external
        }, function () {
          _this.props.onChange(_this.state.internal, external);

          _this.getSelectAll();
        });
      } else {
        // eslint-disable-next-line react/no-access-state-in-setstate
        var internal = _lodash["default"].cloneDeep(_this.state.internal);

        if (internal.indexOf(value) === -1) {
          internal.push(value);
        } else {
          internal.splice(internal.indexOf(value), 1);
        }

        _this.setState({
          internal: internal
        }, function () {
          _this.props.onChange(internal, _this.state.external);

          _this.getSelectAll();
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleDelete", function (value) {
      if (validateEmail(value)) {
        // eslint-disable-next-line react/no-access-state-in-setstate
        var external = _lodash["default"].cloneDeep(_this.state.external);

        if (external.indexOf(value) !== -1) {
          external.splice(external.indexOf(value), 1);
        }

        _this.setState({
          external: external,
          selectAll: 1
        }, function () {
          _this.props.onChange(_this.state.internal, _this.state.external);
        });
      } else {
        // eslint-disable-next-line react/no-access-state-in-setstate
        var internal = _lodash["default"].cloneDeep(_this.state.internal);

        if (internal.indexOf(value) !== -1) {
          internal.splice(internal.indexOf(value), 1);
        }

        _this.setState({
          internal: internal,
          selectAll: 1
        }, function () {
          _this.props.onChange(_this.state.internal, _this.state.external);
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderOptions", function () {
      if (_this.state.filterData.length) {
        return _this.state.filterData.map(function (item) {
          return /*#__PURE__*/_react["default"].createElement(_MenuItem["default"], {
            key: "option-" + (item == null ? void 0 : item.value),
            onClick: function onClick(e) {
              return _this.handleChange(e, item == null ? void 0 : item.value);
            },
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 350,
              columnNumber: 6
            }
          }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
            checked: _this.state.internal.indexOf(item == null ? void 0 : item.value) !== -1 || _this.state.external.indexOf(item == null ? void 0 : item.value) !== -1,
            value: item == null ? void 0 : item.value.toString(),
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 351,
              columnNumber: 7
            }
          }), /*#__PURE__*/_react["default"].createElement("span", {
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 359,
              columnNumber: 7
            }
          }, item.label));
        });
      }

      return /*#__PURE__*/_react["default"].createElement("p", {
        className: "text-muted text-center py-2",
        __self: _assertThisInitialized(_this),
        __source: {
          fileName: _jsxFileName,
          lineNumber: 364,
          columnNumber: 10
        }
      }, _this.props.t('No options are available'));
    });

    _defineProperty(_assertThisInitialized(_this), "renderChips", function (items) {
      return items.map(function (item) {
        return /*#__PURE__*/_react["default"].createElement(_Chip["default"], {
          key: "chip-" + (item == null ? void 0 : item.value),
          label: item.label,
          onDelete: _this.props.disabled === true ? '' : function (e) {
            return _this.handleDelete(item == null ? void 0 : item.value);
          },
          size: "small",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 370,
            columnNumber: 5
          }
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderList", function (items) {
      return items.map(function (item) {
        return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
          alignItems: "start",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 383,
            columnNumber: 5
          }
        }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
          primary: item.label,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 384,
            columnNumber: 6
          }
        }));
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderSelected", function () {
      var width = 500;
      var drawableChips = [];
      var unDrawableChips = [];
      var exceeding = 0;
      var innerWidth = width - 70;

      if (_this.state.internal.length || _this.state.external.length) {
        var data = _this.state.internal.concat(_this.state.external);

        var length = data.length; // eslint-disable-next-line array-callback-return

        _this.state.data.map(function (item, index) {
          if (data.indexOf(item == null ? void 0 : item.value) !== -1) {
            var y = item.label.length * 11 + 20;

            if (innerWidth - y > 0) {
              drawableChips.push(item);
              innerWidth -= y; // eslint-disable-next-line no-plusplus

              length--;
            } else if (index + 1 === _this.state.data.length && innerWidth - y + 70 > 0) {
              drawableChips.push(item);
              innerWidth -= y; // eslint-disable-next-line no-plusplus

              length--;
            } else {
              unDrawableChips.push(item); // eslint-disable-next-line no-plusplus

              exceeding++; // eslint-disable-next-line no-plusplus

              length--;
            }
          }
        });

        var chips = [];

        if (drawableChips.length) {
          chips.push(_this.renderChips(drawableChips));

          if (unDrawableChips.length) {
            chips.push( /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
              title: /*#__PURE__*/_react["default"].createElement(_List["default"], {
                disablePadding: true,
                __self: _assertThisInitialized(_this),
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 427,
                  columnNumber: 23
                }
              }, _this.renderList(unDrawableChips)),
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 427,
                columnNumber: 7
              }
            }, /*#__PURE__*/_react["default"].createElement(_Chip["default"], {
              size: "small",
              key: "chip-more",
              label: unDrawableChips.length + " " + _this.props.t('More'),
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 428,
                columnNumber: 8
              }
            })));
          }

          return chips;
        }

        if (unDrawableChips.length) {
          chips.push( /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
            title: /*#__PURE__*/_react["default"].createElement(_List["default"], {
              disablePadding: true,
              __self: _assertThisInitialized(_this),
              __source: {
                fileName: _jsxFileName,
                lineNumber: 440,
                columnNumber: 22
              }
            }, _this.renderList(unDrawableChips)),
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 440,
              columnNumber: 6
            }
          }, /*#__PURE__*/_react["default"].createElement(_Chip["default"], {
            size: "small",
            key: "chip-more",
            label: unDrawableChips.length + " " + _this.props.t('Options Selected'),
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 441,
              columnNumber: 7
            }
          })));
          return chips;
        }

        return '';
      }

      return '';
    });

    _defineProperty(_assertThisInitialized(_this), "keyPress", function (e) {
      if (e.keyCode === 13 || e.keyCode === 9) {
        var str = _this.state.search;

        if (validateEmail(str)) {
          var newItem = {
            label: str,
            value: str
          };

          _this.state.data.unshift(newItem); // eslint-disable-next-line react/no-access-state-in-setstate


          var newFilterOptions = _lodash["default"].cloneDeep(_this.state.data); // eslint-disable-next-line react/no-access-state-in-setstate


          var external = _lodash["default"].cloneDeep(_this.state.external);

          external.push(newItem == null ? void 0 : newItem.value);

          _this.setState({
            search: '',
            filterData: newFilterOptions,
            external: external
          }, function () {
            _this.props.onChange(_this.state.internal, external);
          });
        } else {
          _this.setState({
            searchError: _this.props.t('You have entered an invalid Email')
          });
        } // eslint-disable-next-line eqeqeq

      } else if (e.keyCode == 27) {
        _this.search({
          target: {
            value: ''
          }
        });

        _this.handleMenuClose();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "clearSearch", function () {
      _this.setState({
        search: ''
      });

      _this.search({
        target: {
          value: ''
        }
      });
    });

    _this.mainControlRef = _react["default"].createRef();
    var newData = [];

    if (props.external && Array.isArray(props.external)) {
      // eslint-disable-next-line array-callback-return
      props.external.map(function (email) {
        newData.push({
          label: email,
          value: email
        });
      });
    }

    if (props == null ? void 0 : props.data) {
      if (props.labelProp && props.valueProp) {
        var labelProp = props.labelProp;
        var valueProp = props.valueProp;
        var options = []; // eslint-disable-next-line array-callback-return

        props.data.map(function (option) {
          options.push({
            label: option[labelProp],
            value: option[valueProp]
          });
        });
        newData = newData.concat(options);
      } else {
        var _options = []; // eslint-disable-next-line array-callback-return

        props.data.map(function (option) {
          _options.push({
            label: option.label,
            // eslint-disable-next-line radix
            value: parseInt(option.value)
          });
        });
        newData = newData.concat(_options);
      }
    }

    _this.state = {
      data: newData,
      open: false,
      search: '',
      internal: props.internal ? arrElToInt(props.internal) : [],
      external: props.external ? props.external : [],
      filterData: _lodash["default"].cloneDeep(newData),
      searchError: null,
      selectAll: 0,
      reRender: true
    };

    _this.getSelectAll();

    return _this;
  }

  var _proto = EmailComplete.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    setTimeout(function () {
      _this2.setState({
        // eslint-disable-next-line react/no-access-state-in-setstate
        reRender: !_this2.state.reRender
      });
    }, 500);
  } // eslint-disable-next-line react/no-deprecated
  ;

  _proto.componentWillReceiveProps = function componentWillReceiveProps(newProps) {
    var _this3 = this;

    if (newProps.internal && JSON.stringify(newProps.internal) !== JSON.stringify(this.state.internal)) {
      this.setState({
        internal: arrElToInt(newProps.internal)
      }, function () {
        _this3.getSelectAll();
      });
    }

    if (newProps.external && JSON.stringify(newProps.external) !== JSON.stringify(this.state.external)) {
      this.setState({
        external: newProps.external
      }, function () {
        _this3.getSelectAll();
      });
    }

    if (newProps.data && Array.isArray(newProps.data) && JSON.stringify(newProps.data) !== JSON.stringify(this.state.data)) {
      var newData = [];

      if (newProps.external && Array.isArray(newProps.external)) {
        // eslint-disable-next-line array-callback-return
        newProps.external.map(function (email) {
          newData.push({
            label: email,
            value: email
          });
        });
      }

      if (newProps.labelProp && newProps.valueProp) {
        var labelProp = newProps.labelProp;
        var valueProp = newProps.valueProp;
        var options = []; // eslint-disable-next-line array-callback-return

        newProps.data.map(function (option) {
          options.push({
            label: option[labelProp],
            value: option[valueProp]
          });
        });
        newData = newData.concat(options);
      } else {
        var _options2 = []; // eslint-disable-next-line array-callback-return

        newProps.data.map(function (option) {
          _options2.push({
            label: option.label,
            // eslint-disable-next-line radix
            value: parseInt(option.value)
          });
        });
        newData = newData.concat(_options2);
      }

      this.setState({
        data: newData,
        filterData: _lodash["default"].cloneDeep(newData)
      }, function () {
        _this3.getSelectAll();
      });
    }
  };

  _proto.render = function render() {
    var adornment;

    if (this.props.disabled === true) {
      adornment = /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
        className: "pb-6",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 503,
          columnNumber: 5
        }
      }, /*#__PURE__*/_react["default"].createElement(_core.Icon, {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 504,
          columnNumber: 6
        }
      }, "arrow_down"));
    } else if (this.state.internal.length || this.state.external.length) {
      adornment = /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
        className: "pb-6",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 509,
          columnNumber: 5
        }
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-times dropdown-icons-clear",
        onClick: this.reset,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 511,
          columnNumber: 6
        }
      }), /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-angle-down dropdown-icons-expand",
        onClick: this.handleMenuOpen,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 513,
          columnNumber: 6
        }
      }));
    } else {
      adornment = /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
        className: "pad-Bot5",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 518,
          columnNumber: 5
        }
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-angle-down dropdown-icons-expand",
        onClick: this.handleMenuOpen,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 520,
          columnNumber: 6
        }
      }));
    }

    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "min-width-120 positionR",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 525,
        columnNumber: 4
      }
    }, /*#__PURE__*/_react["default"].createElement(_ClickAwayListener["default"], {
      onClickAway: this.handleMenuClose,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 526,
        columnNumber: 5
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 527,
        columnNumber: 6
      }
    }, /*#__PURE__*/_react["default"].createElement(_FormControl["default"], {
      fullWidth: true,
      className: "position-relative main-control-" + this.props.id,
      ref: this.mainControlRef,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 528,
        columnNumber: 7
      }
    }, this.props.label && /*#__PURE__*/_react["default"].createElement(_core.InputLabel, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 533,
        columnNumber: 29
      }
    }, this.props.label), /*#__PURE__*/_react["default"].createElement(_Input["default"], {
      defaultValue: "",
      margin: "none",
      disabled: this.props.disabled === true,
      placeholder: this.props.placeholder && (this.state.internal.length || this.state.external.length) ? '' : this.props.placeholder,
      readOnly: true,
      startAdornment: /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 544,
          columnNumber: 25
        }
      }, this.renderSelected()),
      endAdornment: adornment,
      inputProps: {
        onClick: this.handleMenuOpen,
        id: "input-" + this.props.id
      },
      error: this.props.error,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 534,
        columnNumber: 8
      }
    }), ' ', this.props.error ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
      error: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 552,
        columnNumber: 28
      }
    }, this.props.error) : ''), this.state.open ? /*#__PURE__*/_react["default"].createElement(_Paper["default"], {
      className: this.props.position && this.props.position === 'unset' ? 'email-dropdown-paper-unset' : 'email-dropdown-paper',
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 555,
        columnNumber: 8
      }
    }, /*#__PURE__*/_react["default"].createElement(_FormControl["default"], {
      fullWidth: true,
      error: !!this.state.searchError,
      className: "pt-2 px-2 pb-1",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 562,
        columnNumber: 9
      }
    }, this.props.label && /*#__PURE__*/_react["default"].createElement(_core.InputLabel, {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 563,
        columnNumber: 31
      }
    }, this.props.label), /*#__PURE__*/_react["default"].createElement(_Input["default"], {
      autoFocus: true,
      type: "search",
      onChange: this.search,
      value: this.state.search,
      onKeyDown: this.keyPress,
      margin: "dense",
      endAdornment: this.state.search.length ? /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 573,
          columnNumber: 13
        }
      }, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fas fa-times clear-search",
        onClick: this.clearSearch,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 575,
          columnNumber: 14
        }
      })) : '',
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 564,
        columnNumber: 10
      }
    }), this.state.searchError && this.state.searchError != '' ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
      id: "component-error-text",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 587,
        columnNumber: 11
      }
    }, this.state.searchError) : ''), this.state.filterData.length && this.props.includeSelectAll ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "ml-2",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 595,
        columnNumber: 10
      }
    }, /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], {
      onClick: this.selectAll,
      control: /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        color: this.state.selectAll === 1 ? 'default' : 'primary',
        checked: this.state.selectAll === 2,
        indeterminate: this.state.selectAll === 1,
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 599,
          columnNumber: 13
        }
      }),
      label: this.props.t('SELECT_ALL'),
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 596,
        columnNumber: 11
      }
    })) : '', /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      autoHeight: true,
      autoHeightMin: 60,
      autoHeightMax: 250,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 611,
        columnNumber: 9
      }
    }, this.renderOptions())) : null)));
  };

  return EmailComplete;
}(_react["default"].PureComponent);

var _default = (0, _reactI18next.withTranslation)('workflows')(EmailComplete);

exports["default"] = _default;
module.exports = exports.default;